; tabstop=8
;
;
	ORG	09F00H

START:
	JP	ROMCPY
	JP	SUMCALC

WAIT_P:	DB	00H
READ_R:	DB	00H
RESULT:	DW	0000H

ROMCPY:
	LD	HL,0000H
	LD	DE,0000H
	LD	BC,8000H
	LDIR
	RET

SUMCALC:
	DI

	LD	A,0FEH
	OUT	(0B3H),A
	LD	A,0F7H
	OUT	(0B2H),A
	LD	A,0FFH
	OUT	(0B2H),A

	LD	A,(READ_R)
	LD	B,A
	IN	A,(0F0H)
	PUSH	AF
	LD	A,B
	OUT	(0F0H),A	; 11H:BASICROM DDH:RAM

	LD	A,(WAIT_P)
	LD	B,A
	IN	A,(0F3H)
	PUSH	AF
	AND	01FH
	OR	B
	LD	A,B
	OUT	(0F3H),A	; bit7:M1 bit6:ROM bit5:RAM (wait=1)

	CALL	SUMSUB

	POP	AF
	OUT	(0F3H),A

	POP	AF
	OUT	(0F0H),A

	EI
	RET

SUMSUB:
		; ݒ
	LD	A,02H
	OUT	(93H),A

		; 0000H - 7FFFFH ܂ł̃f[^𑫂
	LD	B,10H
SUML2:	PUSH	BC
	LD	HL,0000H
	LD	DE,0000H
	LD	BC,0000H

SUML1:	LD	A,(BC)		; 7  (+M1) (+ROM/RAM read data)
	LD	E,A		; 4  (+M1)
	ADD	HL,DE		; 11 (+M1)
	LD	A,(BC)		; 7  (+M1) (+ROM/RAM read data) (dummy)
	LD	A,(BC)		; 7  (+M1) (+ROM/RAM read data) (dummy)
	LD	A,(BC)		; 7  (+M1) (+ROM/RAM read data) (dummy)
	LD	A,(BC)		; 7  (+M1) (+ROM/RAM read data) (dummy)
	LD	A,(BC)		; 7  (+M1) (+ROM/RAM read data) (dummy)
	LD	A,(BC)		; 7  (+M1) (+ROM/RAM read data) (dummy)
	LD	A,(BC)		; 7  (+M1) (+ROM/RAM read data) (dummy)
	INC	BC		; 6  (+M1)
	LD	A,B		; 4  (+M1)
	CP	80H		; 7  (+M1) (+RAM read operand) (dummy)
	CP	80H		; 7  (+M1) (+RAM read operand) (dummy)
	CP	80H		; 7  (+M1) (+RAM read operand) (dummy)
	CP	80H		; 7  (+M1) (+RAM read operand) (dummy)
	CP	80H		; 7  (+M1) (+RAM read operand) (dummy)
	CP	80H		; 7  (+M1) (+RAM read operand) (dummy)
	CP	80H		; 7  (+M1) (+RAM read operand)
	JR	NZ,SUML1	; 12 (+M1) (+RAM read operand)

	POP	BC
	DJNZ	SUML2

	; M1=1,ROM=1,RAM=0 ̎AROM read:170~32768~16/4MHz=22.28s
	; M1=1,ROM=1,RAM=0 ̎ARAM read:162~32768~16/4MHz=21,23s

	; M1=1,ROM=1,RAM=1 ̎AROM read:178~32768~16/4MHz=23.33s
	; M1=1,ROM=1,RAM=1 ̎ARAM read:170~32768~16/4MHz=22.28s

	; M1=0,ROM=1,RAM=0 ̎AROM read:150~32768~16/4MHz=19.66s
	; M1=0,ROM=1,RAM=0 ̎ARAM read:142~32768~16/4MHz=18.61s

	LD	(RESULT),HL

	LD	A,03H
	OUT	(93H),A
	RET


